//friendto.cpp
//Example:  friend functions

#include <iostream.h>

// class declaration
class friend_class
 {
  // friends list
  friend void real1_add(friend_class&, friend_class&);
  friend void real2_sub(friend_class&, friend_class&);
  private:
         float real1;
         float real2;
  public:
         friend_class(float, float);  // constructor
         void display();
 };

// class implementation
friend_class::friend_class(float r1 = 0, float r2 = 0)
 { real1 = r1;
        real2 = r2;
 }
void friend_class::display()
 { cout << "\nTwo real numbers are: " << real1 << "  " << real2 << endl; }

// friend implementations
void real1_add(friend_class& object1, friend_class& object2)
 { object1.real1 = object2.real1 = (object1.real1 + object2.real1); }
void real2_sub(friend_class &object1, friend_class &object2)
 { object1.real2 = object2.real2 = (object1.real2 - object2.real2); }

void main(void)
 { friend_class object1(3.2, 5.6), object2(1.1, -8.9);
        float sum, difference;

        object1.display();
        object2.display();

        real1_add(object1, object2);
        real2_sub(object1, object2);

        cout << "\nAfter friend function changed the member data for both objects: "
                  << endl;

        object1.display();
        object2.display();

 }
/* The following are the output of this program:

Two real numbers are: 3.2  5.6

Two real numbers are: 1.1  -8.9

After friend function changed the member data for both objects:

Two real numbers are: 4.3  14.5

Two real numbers are: 4.3  14.5
*/